<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>Admin Management | Dashboard 3</title>

  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet"
    href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome Icons -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
  <!-- IonIcons -->
  <link rel="stylesheet" href="https://code.ionicframework.com/ionicons/2.0.1/css/ionicons.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
</head>
<!--
`body` tag options:

  Apply one or more of the following classes to to the body tag
  to get the desired effect

  * sidebar-collapse
  * sidebar-mini
-->

<body class="hold-transition sidebar-mini">
  <div class="wrapper">
    <!-- Navbar -->
    <nav class="main-header navbar navbar-expand navbar-white navbar-light">
      <!-- Left navbar links -->
      <ul class="navbar-nav">
        <li class="nav-item">
          <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
        </li>
        <li class="nav-item d-none d-sm-inline-block">
          <a href="user.html" class="nav-link">Home</a>
        </li>
        <li class="nav-item d-none d-sm-inline-block">
          <a href="#" class="nav-link">Order</a>
        </li>
      </ul>
    </nav>
    <!-- /.navbar -->

    <!-- Main Sidebar Container -->
    <aside class="main-sidebar sidebar-dark-primary elevation-4">
      <!-- Brand Logo -->
      <a href="order.html" class="brand-link">
        <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3"
          style="opacity: .8">
        <span class="brand-text font-weight-light">Admin</span>
      </a>

      <!-- Sidebar -->
      <div class="sidebar">
        <!-- Sidebar user panel (optional) -->
        <div class="user-panel mt-3 pb-3 mb-3 d-flex">
          <div class="image">
            <img src="dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
          </div>
          <div class="info">
            <a href="#" class="d-block">Anh Luong</a>
          </div>
        </div>

        <!-- SidebarSearch Form -->
        <div class="form-inline">
          <div class="input-group" data-widget="sidebar-search">
            <input class="form-control form-control-sidebar" type="search" placeholder="Search" aria-label="Search">
            <div class="input-group-append">
              <button class="btn btn-sidebar">
                <i class="fas fa-search fa-fw"></i>
              </button>
            </div>
          </div>
        </div>

        <!-- Sidebar Menu -->
        <nav class="mt-2">
          <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
            <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
            <li class="nav-item menu-open">
              <a href="#" class="nav-link active">
                <i class="nav-icon fas fa-tachometer-alt"></i>
                <p>
                  Admin
                  <i class="right fas fa-angle-left"></i>
                </p>
              </a>
              <ul class="nav nav-treeview">
                <li class="nav-item">
                  <a href="user.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Users</p>
                  </a>
                </li>
                <li class="nav-item">
                  <a href="product.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Products</p>
                  </a>
                </li>
                <li class="nav-item">
                  <a href="order.html" class="nav-link active">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Orders</p>
                  </a>
                </li>
              </ul>
            </li>
          </ul>
        </nav>
        <!-- /.sidebar-menu -->
      </div>
      <!-- /.sidebar -->
    </aside>

    <!-- Content Wrapper. Contains page content -->
    <div class="content-wrapper">
      <!-- Content Header (Page header) -->
      <div class="content-header">
        <div class="container-fluid">
          <div class="row mb-2">
            <div class="col-sm-6">
              <h1 class="m-0">Order List</h1>
            </div><!-- /.col -->
            <div class="col-sm-6">
              <ol class="breadcrumb float-sm-right">
                <li class="breadcrumb-item"><a href="#">Home</a></li>
                <li class="breadcrumb-item active">Order</li>
              </ol>
            </div><!-- /.col -->
          </div><!-- /.row -->
        </div><!-- /.container-fluid -->
      </div>
      <!-- /.content-header -->

      <!-- Main content -->
      <div class="container">
        <h2 class="text-center">Danh sách đơn hàng</h2>
        <div class="jumbotron container">
          <div class="row form-group">
            <div class="col-md-5 row">
              <div class="col-md-6 text-center">
                <label class="form-group mx-2">Trạng thái Order</label>
              </div>
              <div class="col-md-6">
                <select id="select-status" class="form-control">
                  <option value="all">All</option>
                  <option value="open">Open</option>
                  <option value="confirmed">Confirmed</option>
                  <option value="cancel">Cancel</option>
                </select>
              </div>
            </div>
            <div class="col-md-5 row">
              <div class="col-md-6 text-center">
                <label class="form-group mx-2">Loại Pizza</label>
              </div>
              <div class="col-md-6">
                <select id="select-pizza" class="form-control">
                  <option value="all">All</option>
                  <option value="hawaii">Hawaii</option>
                  <option value="bacon">Bacon</option>
                  <option value="seafood">Seafood</option>
                </select>
              </div>
            </div>
            <div class="col-md-2">
              <div class="col-md-12 text-right">
                <button class="btn btn-success" id="btn-filter">Lọc</button>
              </div>
            </div>
          </div>
        </div>
        <table id="order-table" class="table table-striped table-bordered table-hover">
          <thead>
            <tr>
              <th>Order Code</th>
              <th>Kích cỡ Combo</th>
              <th>Loại Pizza</th>
              <th>Nước uống</th>
              <th>Thành tiền</th>
              <th>Họ và tên</th>
              <th>Số điện thoại</th>
              <th>Trạng thái</th>
              <th>Action</th>
            </tr>
          </thead>
        </table>
      </div>
      <!-- Modal order info -->
      <div id="order-modal" class="modal fade text-center" tabindex="-1">
        <div class="modal-dialog">
          <div class="modal-content" style="width: 800px;">
            <div class="modal-header">
              <h5 class="modal-title">Order Detail!</h5>
              <button type="button" class="close" data-dismiss="modal">&times;</button>
            </div>
            <!-- Modal body -->
            <div class="modal-body">
              <div class="form-group row">
                <div class="col-md-2">
                  <label for="">Order Code</label>
                </div>
                <div class="col-md-10">
                  <input id="inp-ordercode" class="form-control" type="text">
                </div>
              </div>
              <div class="form-group row">
                <div class="col-md-2">
                  <label for="">Pizza Size</label>
                </div>
                <div class="col-md-10">
                  <select id="select-pizzasize" class="form-control"></select>
                </div>
              </div>
              <div class="form-group row">
                <div class="col-md-2">
                  <label for="">Đường kính</label>
                </div>
                <div class="col-md-10">
                  <input id="inp-duongkinh" class="form-control" type="text">
                </div>
              </div>
              <div class="form-group row">
                <div class="col-md-2">
                  <label for="">Sườn</label>
                </div>
                <div class="col-md-10">
                  <input id="inp-suon" class="form-control" type="text">
                </div>
              </div>
              <div class="form-group row">
                <div class="col-md-2">
                  <label for="">Salad</label>
                </div>
                <div class="col-md-10">
                  <input id="inp-salad" class="form-control" type="text">
                </div>
              </div>
              <div class="form-group row">
                <div class="col-md-2">
                  <label for="">Pizza Type</label>
                </div>
                <div class="col-md-10">
                  <input id="inp-pizzatype" class="form-control" type="text">
                </div>
              </div>
              <div class="form-group row">
                <div class="col-md-2">
                  <label for="">ID Voucher</label>
                </div>
                <div class="col-md-10">
                  <input id="inp-idvoucher" class="form-control" type="text">
                </div>
              </div>
              <div class="form-group row">
                <div class="col-md-2">
                  <label for="">Thành tiền</label>
                </div>
                <div class="col-md-10">
                  <input id="inp-thanhtien" class="form-control" type="text">
                </div>
              </div>
              <div class="form-group row">
                <div class="col-md-2">
                  <label for="">Giảm giá</label>
                </div>
                <div class="col-md-10">
                  <input id="inp-giamgia" class="form-control" type="text">
                </div>
              </div>
              <div class="form-group row">
                <div class="col-md-2">
                  <label for="">Loại đồ uống</label>
                </div>
                <div class="col-md-10">
                  <select id="select-drink" class="form-control"></select>
                </div>
              </div>
              <div class="form-group row">
                <div class="col-md-2">
                  <label for="">Số lượng nước uống</label>
                </div>
                <div class="col-md-10">
                  <input id="inp-soluongdrink" class="form-control" type="text">
                </div>
              </div>
              <div class="form-group row">
                <div class="col-md-2">
                  <label for="">Họ và tên</label>
                </div>
                <div class="col-md-10">
                  <input id="inp-hoten" class="form-control" type="text">
                </div>
              </div>
              <div class="form-group row">
                <div class="col-md-2">
                  <label for="">Email</label>
                </div>
                <div class="col-md-10">
                  <input id="inp-email" class="form-control" type="text">
                </div>
              </div>
              <div class="form-group row">
                <div class="col-md-2">
                  <label for="">Số điện thoại</label>
                </div>
                <div class="col-md-10">
                  <input id="inp-phone" class="form-control" type="text">
                </div>
              </div>
              <div class="form-group row">
                <div class="col-md-2">
                  <label for="">Địa chỉ</label>
                </div>
                <div class="col-md-10">
                  <input id="inp-address" class="form-control" type="text">
                </div>
              </div>
              <div class="form-group row">
                <div class="col-md-2">
                  <label for="">Lời nhắn</label>
                </div>
                <div class="col-md-10">
                  <input id="inp-message" class="form-control" type="text">
                </div>
              </div>
              <div class="form-group row">
                <div class="col-md-2">
                  <label for="">Ngày order</label>
                </div>
                <div class="col-md-10">
                  <input id="inp-orderday" class="form-control" type="text">
                </div>
              </div>
              <div class="form-group row">
                <div class="col-md-2">
                  <label for="">Ngày chỉnh sửa</label>
                </div>
                <div class="col-md-10">
                  <input id="inp-updatedate" class="form-control" type="text">
                </div>
              </div>
              <div class="form-group row">
                <div class="col-sm-6 form-group">
                  <button id="btn-confirm" class="btn btn-warning col-sm-12">Confirm</button>
                </div>
                <div class="col-sm-6 form-group">
                  <button id="btn-cancel" class="btn btn-danger col-sm-12">Cancel</button>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
      <!-- /.content -->
    </div>
    <!-- /.content-wrapper -->

    <!-- Control Sidebar -->
    <aside class="control-sidebar control-sidebar-dark">
      <!-- Control sidebar content goes here -->
    </aside>
    <!-- /.control-sidebar -->

    <!-- Main Footer -->
    <footer class="main-footer">
      <strong>Copyright &copy; 2020-2023 <a href="https://adminlte.io">Devcamp 120</a>.</strong>
      All rights reserved.
      <div class="float-right d-none d-sm-inline-block">
        <b>Version</b> 2.5.5
      </div>
    </footer>
  </div>
  <!-- ./wrapper -->

  <!-- REQUIRED SCRIPTS -->

  <!-- jQuery -->
  <script src="plugins/jquery/jquery.min.js"></script>
  <!-- Bootstrap -->
  <script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
  <!-- AdminLTE -->
  <script src="dist/js/adminlte.js"></script>

  <!-- OPTIONAL SCRIPTS -->
  <script src="plugins/chart.js/Chart.min.js"></script>
  <!-- AdminLTE for demo purposes -->
  <script src="dist/js/demo.js"></script>
  <!-- AdminLTE dashboard demo (This is only for demo purposes) -->
  <script src="dist/js/pages/dashboard3.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
  <script>
    "use strict";
    $(document).ready(function () {
      /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
      var gId;
      var gOrderCode;
      var gDataOrders = []; //khai báo biến array để chứa data order
      var gPizaaSize = ["S", "M", "L"]; //khai báo array chứa giá trị kích cỡ của pizza size
      const gORDER = ["orderCode", "kichCo", "loaiPizza", "idLoaiNuocUong", "thanhTien", "hoTen", "soDienThoai", "trangThai", "action"];
      const gCOLUMN_ORDER_CODE = 0;
      const gCOLUMN_KICH_CO = 1;
      const gCOLUMN_LOAI_PIZZA = 2;
      const gCOLUMN_ID_LOAI_NUOC_DUNG = 3;
      const gCOLUMN_THANH_TIEN = 4;
      const gCOLUMN_HO_TEN = 5;
      const gCOLUMN_SO_DIEN_THOAI = 6;
      const gCOLUMN_TRANG_THAI = 7;
      const gCOLUMN_ACTION = 8;
      //định nghĩa table - chưa có data
      $("#order-table").DataTable({
        "columns": [
          { "data": gORDER[gCOLUMN_ORDER_CODE] },
          { "data": gORDER[gCOLUMN_KICH_CO] },
          { "data": gORDER[gCOLUMN_LOAI_PIZZA] },
          { "data": gORDER[gCOLUMN_ID_LOAI_NUOC_DUNG] },
          { "data": gORDER[gCOLUMN_THANH_TIEN] },
          { "data": gORDER[gCOLUMN_HO_TEN] },
          { "data": gORDER[gCOLUMN_SO_DIEN_THOAI] },
          { "data": gORDER[gCOLUMN_TRANG_THAI] },
          { "data": gORDER[gCOLUMN_ACTION] }
        ],
        //ghi đè nội dung cột action, chuyển thành button Chi tiết
        "columnDefs": [
          {
            "targets": gCOLUMN_ACTION,
            "defaultContent": "<button class='btn-detail btn btn-primary'>Chi tiết</button>"
          }
        ]
      });
      /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
      onPageLoading();
      //gọi hàm hiển thị ds đồ uống vào select
      getDrinkList();
      //gọi hàm hiển thị kích cỡ pizza vào select
      getPizzaSizeList(gPizaaSize);
      //gán sự kiện cho nút Chi tiết
      $("#order-table").on("click", ".btn-detail", function () {
        onBtnDetailClick(this);
      });
      //gán sự kiện cho nút Lọc
      $("#btn-filter").on("click", function () {
        onBtnFilterClick();
      });
      //gán sự kiện cho nút Confirm
      $("#btn-confirm").on("click", function () {
        onBtnConfirmClick();
      });
      //gán sự kiện cho nút Cancel
      $("#btn-cancel").on("click", function () {
        onBtnCancelClick();
      });
      /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
      function onPageLoading() {
        $.ajax({
          url: "http://203.171.20.210:8080/devcamp-pizza365/orders",
          type: "GET",
          dataType: "json",
          success: function (res) {
            gDataOrders = res;
            console.log(gDataOrders);
            loadDataToTable(gDataOrders); //gọi hàm load data vào table
          },
          error: function (err) {
            console.assert(err.responseText);
          }
        });
      }
      //hàm xử lý sự kiện nút Lọc
      function onBtnFilterClick() {
        var vStatus = $("#select-status").val();
        var vPizzaType = $("#select-pizza").val();
        var vDataFilter = gDataOrders.filter(function (paramOrder, index) {
          return (vStatus == "all" || vStatus.toUpperCase() === paramOrder.trangThai.toUpperCase())
            && (vPizzaType == "all" || vPizzaType.toUpperCase() === paramOrder.loaiPizza.toUpperCase())
        });
        //gọi hàm load data vào table
        loadDataToTable(vDataFilter);
      }
      //hàm xử lý nút Confirm trên modal
      function onBtnConfirmClick() {
        console.log("ID: " + gId);
        var vObjectRequestData = {
          trangThai: "confirmed"
        }
        $.ajax({
          url: "http://203.171.20.210:8080/devcamp-pizza365/orders/" + gId,
          type: 'PUT',
          contentType: 'application/json',
          data: JSON.stringify(vObjectRequestData), //chuyển obj thành json string
          success: function (responseObj) {
            console.log(responseObj);
            loadDataToTable(gDataOrders);
            $("#order-modal").modal("hide");
            onPageLoading();
          },
          error: function (ajaxContext) {
            alert(ajaxContext.responseText);
          }
        });
      }
      //hàm xử lý nút Confirm trên modal
      function onBtnCancelClick() {
        console.log("ID: " + gId);
        var vObjectRequestData = {
          trangThai: "cancel"
        }
        $.ajax({
          url: "http://203.171.20.210:8080/devcamp-pizza365/orders/" + gId,
          type: 'PUT',
          contentType: 'application/json',
          data: JSON.stringify(vObjectRequestData), //chuyển obj thành json string
          success: function (responseObj) {
            console.log(responseObj);
            loadDataToTable(gDataOrders);
            $("#order-modal").modal("hide");
            onPageLoading();
          },
          error: function (ajaxContext) {
            alert(ajaxContext.responseText);
          }
        });
      }
      /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
      //hàm load data vào table
      function loadDataToTable(paramResponseObj) {
        var vOrderTable = $("#order-table").DataTable();
        vOrderTable.clear(); //xóa trắng data đang có của table
        vOrderTable.rows.add(paramResponseObj); //cập nhật data cho table
        vOrderTable.draw(); //vẽ lại table
      }

      //hàm xử lý sự kiện nút Chi tiết
      function onBtnDetailClick(paramDetailButton) {
        var vRowSelected = $(paramDetailButton).closest("tr");
        var vOrderTable = $("#order-table").DataTable();
        var vDataTableRow = vOrderTable.row(vRowSelected).data();
        gId = vDataTableRow.id;
        gOrderCode = vDataTableRow.orderCode;
        console.log("ID: " + gId);
        console.log("Order Code: " + gOrderCode);
        getAjaxDetailOrder(gOrderCode);
        $("#order-modal").modal("show");
      }

      //hàm gọi api get drink list
      function getDrinkList() {
        $.ajax({
          url: "http://203.171.20.210:8080/devcamp-pizza365/drinks",
          type: "GET",
          success: function (res) {
            handleDrinkList(res);
          },
          error: function (ajaxContext) {
            alert(ajaxContext.responseText);
          }
        });
      }

      //hàm tạo option cho select drink
      function handleDrinkList(paramDrink) {
        $.each(paramDrink, function (i, item) {
          $("#select-drink").append($("<option>", {
            text: item.tenNuocUong,
            value: item.maNuocUong
          }));
        });
      }

      //hàm tạo option cho select pizza size
      function getPizzaSizeList(paramPizza) {
        $.each(paramPizza, function (i, item) {
          $("#select-pizzasize").append($("<option>", {
            text: item,
            value: item.toLowerCase()
          }));
        });
      }

      //hàm gọi api order theo orderCode
      function getAjaxDetailOrder(paramOrderCode) {
        $.ajax({
          url: "http://203.171.20.210:8080/devcamp-pizza365/orders/" + paramOrderCode,
          dataType: "json",
          type: "GET",
          success: function (paramOrder) {
            console.log(paramOrder);
            //gọi hàm hiển thị data order lên modal
            handleOrderDetail(paramOrder);
          },
          error: function (ajaxContext) {
            alert(ajaxContext.responseText);
          }
        });
      }

      //hàm đổ data vào modal
      function handleOrderDetail(paramResponse) {
        $("#inp-ordercode").val(paramResponse.orderCode);
        $("#select-pizzasize").val(paramResponse.kichCo.toLowerCase());
        $("#inp-duongkinh").val(paramResponse.duongKinh);
        $("#inp-suon").val(paramResponse.suon);
        $("#inp-salad").val(paramResponse.salad);
        $("#inp-pizzatype").val(paramResponse.loaiPizza);
        $("#inp-idvoucher").val(paramResponse.idVourcher);
        $("#inp-thanhtien").val(paramResponse.thanhTien);
        $("#inp-giamgia").val(paramResponse.giamGia);
        $("#select-drink").val(paramResponse.idLoaiNuocUong);
        $("#inp-soluongdrink").val(paramResponse.soLuongNuoc);
        $("#inp-hoten").val(paramResponse.hoTen);
        $("#inp-email").val(paramResponse.email);
        $("#inp-phone").val(paramResponse.soDienThoai);
        $("#inp-address").val(paramResponse.diaChi);
        $("#inp-message").val(paramResponse.loiNhan);
        $("#inp-orderday").val(paramResponse.ngayTao);
        $("#inp-updatedate").val(paramResponse.ngayCapNhat);
      }
    });
  </script>
</body>

</html>